#
# Copyright (c) 2008-2018 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_skin.interfaces.configuration import IBackOfficeConfiguration
from pyams_skin.interfaces.metas import IHTMLContentMetas
from pyams_utils.interfaces.site import ISiteRoot
from pyams_zmi.layer import IAdminLayer

# import packages
from pyams_skin.metas import HTMLTagMeta
from pyams_utils.adapter import adapter_config, ContextRequestViewAdapter
from zope.interface import Interface


@adapter_config(name='title', context=(Interface, IAdminLayer, Interface), provides=IHTMLContentMetas)
@adapter_config(name='title', context=(ISiteRoot, IAdminLayer, Interface), provides=IHTMLContentMetas)
class TitleMetasAdapter(ContextRequestViewAdapter):
    """Title metas adapter"""

    order = 1

    def get_metas(self):
        config = IBackOfficeConfiguration(self.request.root)
        yield HTMLTagMeta('title', config.title,
                          **{'data-ams-title-prefix': config.get_title_prefix(self.request)})
